package jp.co.ulsystems.tools.taglets;

import java.lang.reflect.Method;
import java.util.Map;

import com.sun.javadoc.Doc;
import com.sun.javadoc.ProgramElementDoc;
import com.sun.javadoc.Tag;
import com.sun.tools.doclets.Taglet;

public class TestTaglet implements Taglet {

    public String getName() {
        return "test";
    }

    public boolean inField() {
        return true;
    }

    public boolean inConstructor() {
        return true;
    }

    public boolean inMethod() {
        return true;
    }

    public boolean inOverview() {
        return true;
    }

    public boolean inPackage() {
        return true;
    }

    public boolean inType() {
        return true;
    }

    public boolean isInlineTag() {
        return false;
    }

    public static void register(Map tagletMap) {
        TestTaglet taglet  = new TestTaglet();
        Taglet t = (Taglet) tagletMap.get(taglet.getName());
        if (t != null) {
            tagletMap.remove(taglet.getName());
        }
        tagletMap.put(taglet.getName(), taglet);
    }

    public String toString(Tag tag) {
        Doc holder = tag.holder();
        StringBuffer buff = new StringBuffer();
        String absoluteHolderName = ((ProgramElementDoc)holder).qualifiedName();
        String absoluteTestClassName = null;
        String testClassName = null;
        Class testClass = null;
        String testMethodPrefix = null;

        if(holder.isClass()){
            absoluteTestClassName = new StringBuffer(absoluteHolderName).insert(absoluteHolderName.lastIndexOf(".") + 1, "Test").toString();
            testClassName = new StringBuffer(absoluteTestClassName).delete(0, absoluteTestClassName.lastIndexOf(".") + 1).toString();
            try{
                testClass = Class.forName(absoluteTestClassName);
            }catch(Exception e){
                System.err.println();
                e.printStackTrace();
                return null;
            }
            buff.append("<dt><b>eXgNX:&nbsp;</b></dt><dd><a href='").append(testClassName).append(".html'>").append(testClassName).append("</a></dd>");
        }else if(holder.isMethod()){
            absoluteTestClassName = new StringBuffer(absoluteHolderName).insert(absoluteHolderName.lastIndexOf(".", absoluteHolderName.lastIndexOf(".") - 1) + 1, "Test").substring(0, absoluteHolderName.lastIndexOf(".") + 4).toString();
            testClassName = absoluteTestClassName.substring(absoluteTestClassName.lastIndexOf(".") + 1);
            testMethodPrefix = new StringBuffer(holder.name()).replace(0, 1, holder.name().substring(0, 1).toUpperCase()).insert(0, "test").toString();

           try{
                testClass = Class.forName(absoluteTestClassName);
            }catch(Exception e){
                System.err.println();
                e.printStackTrace();
                return null;
            }
            Method[] testMethods = testClass.getMethods();

            for(int j=0; j<testMethods.length; j++){
                if(testMethods[j].getName().startsWith(testMethodPrefix)){
                    buff.append("<dt><b>eXg\bh:&nbsp;</b></dt><dd><a href='").append(testClassName).append(".html#").append(testMethods[j].getName()).append("()'>").append(testMethods[j].getName()).append("</a></dd>");
                }
            }
        }
        return buff.toString();
    }

    public String toString(Tag[] tags) {
        if(tags == null
        || tags.length == 0){
            return null;
        }
        return toString(tags[0]);
    }
}
